package trelica;

import javax.swing.*;
import java.io.*;

class Metaheuristica {

  public static void main(String args[]) {
    Implementacao i = new Implementacao();
    i.inicio();
    System.exit(0);
  }

} // fim da classe Metaheuristica

class Implementacao {

  void inicio() {

    double peso_trelica = 0, // peso da estrutura na solucao corrente
        fo = 0, // funcao objetivo da solucao corrente
        densidade_barra = 0.1, // densidade do material de cada barra (valor constante)
        // vetor de area de cada barra presente no mercado
        // 42 barras presentes no mercado
        a[] = {
        1.62, 1.80, 1.99, 2.13, 2.38, 2.62, 2.63, 2.88, 2.93, 3.09,
        3.13, 3.38, 3.47, 3.55, 3.63, 3.84, 3.87, 3.88, 4.18, 4.22,
        4.49, 4.59, 4.80, 4.97, 5.12, 5.74, 7.22, 7.97, 11.5, 13.5,
        13.9, 14.2, 15.5, 16.0, 16.9, 18.8, 19.9, 22.0, 22.9, 26.5,
        30.0, 33.5},
        // vetor solucao corrente (composto por reas)
        s[] = new double[10],

        // vetor de comprimento de cada barra da soluo (fornecido no mtodo)
        d[] = new double[10],
        // vetor de tenso de cada barra da soluo (fornecido no mtodo)
        t[] = new double[10],
        // preenche o vetor deslocamento da soluo corrente
        u[] = new double[12],
        // vetor (tensao_barra / tensao_max) para cada barra da soluo
        tensao_quoc[] = new double[10],
        // vetor (desl_barra / desl_max) para cada barra da soluo
        desl_quoc[] = new double[12],
        retorno[] = new double[2];

    // mximo admissvel para os deslocamentos das barras (valor constante)
    int deslocamento_max = 2, /* Limite superior: + 2
                    Limite inferior: - 2 */
        // mximo admissvel para as tenses das barras (valor constante)
        tensao_max = 25000, /* Limite superior: + 25000
                    Limite inferior: - 25000 */
        choice; // escolha do menu

    do {

      choice = menu_principal();

      switch (choice) {

        case 1:

              /*----------------------------------------------------------------------
               Geracao de uma solucao inicial
               ----------------------------------------------------------------------*/
          do {

            // preenche o vetor *s, *d e *v
            constroi_solucao_aleatoria(s, a);

               /* Chama o mtodo para calcular a tenso e o deslocamento da soluo corrente.
                    Aps isso, preenchemos o vetor d, t, u  */
           calculos(s, d, t, u);

            peso_trelica = calcula_peso_trelica(s, d, densidade_barra);

            set_vetores_quociente(deslocamento_max, tensao_max, t, u,
                                  tensao_quoc, desl_quoc);

            fo = calcula_fo(peso_trelica, tensao_quoc, desl_quoc);

          }while (fo != peso_trelica);

          System.out.println("\n ----------- Solucao aleatoria ------------\n");
          imprime_solucao(s, d, t, fo, peso_trelica);

          break;

        case 2:

              /*--------------------------------------------------------------------
                 VND
               --------------------------------------------------------------------*/
          if (fo != 0) {
            retorno = vnd(a, s, fo, densidade_barra, deslocamento_max,
                          tensao_max,
                          peso_trelica, d, t, u, tensao_quoc, desl_quoc);
            fo = retorno[0];
            peso_trelica = retorno[1];

            System.out.println("\n ----------- Solucao refinada ------------\n");
            imprime_solucao(s, d, t, fo, peso_trelica);

          }
          else {
            System.out.println("\n ------- Gere uma solucao inicial --------\n");
          }
          break;

        case 3:

              /*--------------------------------------------------------------------
                 VND
               --------------------------------------------------------------------*/
          if (fo != 0) {
            retorno = vns(a, s, fo, densidade_barra, deslocamento_max,
                          tensao_max,
                          peso_trelica, d, t, u, tensao_quoc, desl_quoc);

            fo = retorno[0];
            peso_trelica = retorno[1];

            System.out.println("\n ----------- Solucao refinada ------------\n");
            imprime_solucao(s, d, t, fo, peso_trelica);
          }
          else {
            System.out.println("\n ----- Gere uma solucao inicial ------\n");
          }
          break;

      } // fim do switch
    }
    while (choice != 0);
  } // fim do mtodo inicio

      /*----------------------------------------------------------------------------
        MTODOS AUXILIARES
       ----------------------------------------------------------------------------*/
  private int menu_principal() {
    int escolha;
    do {
      escolha = Integer.parseInt(JOptionPane.showInputDialog(null,
          "1.   Gerar solucao inicial aleatria \n"
          + "2.   VND \n"
          + "3.   VNS \n"
          + "0.   Sair \n", "Opes", JOptionPane.QUESTION_MESSAGE));
    }
    while (escolha < 0 || escolha > 3);
    return escolha;
  } // fim do mtodo menu_principal

  // constroi uma solucao inicial aleatoria
  private void constroi_solucao_aleatoria(double[] s, double[] a) {
    int i;
    for (int j = 0; j < s.length; j++) {
      i = (int) (Math.random() * (a.length - 1));
      s[j] = a[i];
    }
  } // fim do mtodo constroi_solucao_aleatoria

  private void imprime_solucao(double[] s, double[] d, double[] t,
                               double fo, double peso_trelica) {
    System.out.println("[rea]  |  [comprimento]  |  [tenso]\n");
    for (int j = 0; j < 10; j++) {
      System.out.println(" " + s[j] + "   |   " + d[j] + "   |   " + t[j] +
                         "\n");
    }
    System.out.println("Funo objetivo = " + fo + "\n" +
                       "Peso da trelia = " + peso_trelica + "\n");
  } // fim do mtodo imprime_solucao

  private double calcula_peso_trelica(double[] s, double[] d,
                                      double densidade_barra) {
    double peso = 0;
    for (int j = 0; j < s.length; j++) {
      peso += (s[j]) * (d[j]) * (densidade_barra);
    }
    return peso;
  } // fim do mtodo calcula_peso_trelica

  private void set_vetores_quociente(int deslocamento_max, int tensao_max,
                                     double[] t,
                                     double[] u, double[] tensao_quoc,
                                     double[] desl_quoc) {
    for (int j = 0; j < 10; j++) {
      tensao_quoc[j] = (t[j] / tensao_max) - 1;
    }
    for (int j = 0; j < 12; j++) {
      desl_quoc[j] = (u[j] / deslocamento_max) - 1;
    }
  } // fim do mtodo set_vetores_quociente

  private double calcula_fo(double peso_trelica, double[] tensao_quoc,
                            double[] desl_quoc) {
    double fo, aux = 0;
    for (int j = 0; j < 10; j++) {
      if (tensao_quoc[j] > 0)
        aux += tensao_quoc[j];
    }
    for (int j = 0; j < 12; j++) {
      if (desl_quoc[j] > 0)
        aux += desl_quoc[j];
    }
    fo = peso_trelica + aux;
    return fo;
  } // fim do mtodo calcula_fo

  private double[] um_para_cima(int i, int j, int deslocamento_max,
                                int tensao_max,
                                double[] a, double[] s_aux, double fo_melhor,
                                double densidade_barra, double[] d_aux,
                                double[] t_aux,
                                double[] u_aux, double[] tensao_quoc_aux,
                                double[] desl_quoc_aux, double fo_aux,
                                double peso_trelica_aux) {

    double dados[] = {
        fo_aux, fo_melhor, peso_trelica_aux};

    double a_aux = s_aux[i];
    s_aux[i] = a[j + 1];

        /* Chama o mtodo para calcular a tenso e o deslocamento da soluo corrente.
          Aps isso, preenchemos o vetor d, t, u  */
    calculos(s_aux, d_aux, t_aux, u_aux);

    peso_trelica_aux = calcula_peso_trelica(s_aux, d_aux, densidade_barra);

    set_vetores_quociente(deslocamento_max, tensao_max, t_aux, u_aux,
                          tensao_quoc_aux, desl_quoc_aux);

    fo_aux = calcula_fo(peso_trelica_aux, tensao_quoc_aux, desl_quoc_aux);

    if (fo_aux == peso_trelica_aux && fo_aux < fo_melhor) {
      fo_melhor = fo_aux;
      dados[0] = fo_aux;
      dados[1] = fo_melhor;
      dados[2] = peso_trelica_aux;
    }
    else {
      s_aux[i] = a_aux;
      calculos(s_aux, d_aux, t_aux, u_aux);
    }
    return dados;

  } // fim do mtodo um_para_cima

  private double[] um_para_baixo(int i, int j, int deslocamento_max,
                                 int tensao_max,
                                 double[] a, double[] s_aux, double fo_melhor,
                                 double densidade_barra, double[] d_aux,
                                 double[] t_aux,
                                 double[] u_aux, double[] tensao_quoc_aux,
                                 double[] desl_quoc_aux, double fo_aux,
                                 double peso_trelica_aux) {

    double dados[] = {
        fo_aux, fo_melhor, peso_trelica_aux};

    double a_aux = s_aux[i];
    s_aux[i] = a[j - 1];

        /* Chama o mtodo para calcular a tenso e o deslocamento da soluo corrente.
          Aps isso, preenchemos o vetor d, t, u  */
    calculos(s_aux, d_aux, t_aux, u_aux);

    peso_trelica_aux = calcula_peso_trelica(s_aux, d_aux, densidade_barra);

    set_vetores_quociente(deslocamento_max, tensao_max, t_aux, u_aux,
                          tensao_quoc_aux, desl_quoc_aux);

    fo_aux = calcula_fo(peso_trelica_aux, tensao_quoc_aux, desl_quoc_aux);

    if (fo_aux == peso_trelica_aux && fo_aux < fo_melhor) {
      fo_melhor = fo_aux;
      dados[0] = fo_aux;
      dados[1] = fo_melhor;
      dados[2] = peso_trelica_aux;
    }
    else {
      s_aux[i] = a_aux;
      calculos(s_aux, d_aux, t_aux, u_aux);
    }

    return dados;

  } // fim do mtodo um_para_baixo

  private double[] dois_para_cima(int i, int j, int deslocamento_max,
                                  int tensao_max,
                                  double[] a, double[] s_aux, double fo_melhor,
                                  double densidade_barra, double[] d_aux,
                                  double[] t_aux,
                                  double[] u_aux, double[] tensao_quoc_aux,
                                  double[] desl_quoc_aux, double fo_aux,
                                  double peso_trelica_aux) {

    double dados[] = {
        fo_aux, fo_melhor, peso_trelica_aux};

    double a_aux = s_aux[i];
    s_aux[i] = a[j + 2];

        /* Chama o mtodo para calcular a tenso e o deslocamento da soluo corrente.
          Aps isso, preenchemos o vetor d, t, u  */
    calculos(s_aux, d_aux, t_aux, u_aux);

    peso_trelica_aux = calcula_peso_trelica(s_aux, d_aux, densidade_barra);

    set_vetores_quociente(deslocamento_max, tensao_max, t_aux, u_aux,
                          tensao_quoc_aux, desl_quoc_aux);

    fo_aux = calcula_fo(peso_trelica_aux, tensao_quoc_aux, desl_quoc_aux);

    if (fo_aux == peso_trelica_aux && fo_aux < fo_melhor) {

      fo_melhor = fo_aux;
      dados[0] = fo_aux;
      dados[1] = fo_melhor;
      dados[2] = peso_trelica_aux;
    }
    else {
      s_aux[i] = a_aux;
      calculos(s_aux, d_aux, t_aux, u_aux);
    }
    return dados;
  } // fim do mtodo um_para_cima

  private double[] dois_para_baixo(int i, int j, int deslocamento_max,
                                   int tensao_max,
                                   double[] a, double[] s_aux, double fo_melhor,
                                   double densidade_barra, double[] d_aux,
                                   double[] t_aux,
                                   double[] u_aux, double[] tensao_quoc_aux,
                                   double[] desl_quoc_aux, double fo_aux,
                                   double peso_trelica_aux) {

    double dados[] = {
        fo_aux, fo_melhor, peso_trelica_aux};

    double a_aux = s_aux[i];
    s_aux[i] = a[j - 2];

        /* Chama o mtodo para calcular a tenso e o deslocamento da soluo corrente.
           Aps isso, preenchemos o vetor d, t, u  */
    calculos(s_aux, d_aux, t_aux, u_aux);

    peso_trelica_aux = calcula_peso_trelica(s_aux, d_aux, densidade_barra);

    set_vetores_quociente(deslocamento_max, tensao_max, t_aux, u_aux,
                          tensao_quoc_aux, desl_quoc_aux);

    fo_aux = calcula_fo(peso_trelica_aux, tensao_quoc_aux, desl_quoc_aux);

    if (fo_aux == peso_trelica_aux && fo_aux < fo_melhor) {
      fo_melhor = fo_aux;
      dados[0] = fo_aux;
      dados[1] = fo_melhor;
      dados[2] = peso_trelica_aux;
    }
    else {
      s_aux[i] = a_aux;
      calculos(s_aux, d_aux, t_aux, u_aux);
    }
    return dados;
  } // fim do mtodo um_para_baixo

      /*----------------------------------------------------------------------------
      VND
       ---------------------------------------------------------------------------*/
  private double[] vnd(double[] a, double[] s, double fo,
                       double densidade_barra,
                       int deslocamento_max, int tensao_max,
                       double peso_trelica,
                       double[] d, double[] t, double[] u, double[] tensao_quoc,
                       double[] desl_quoc) {

    // vetor solucao corrente auxiliar
    double s_aux[] = new double[10],
        // vetor de comprimento de cada barra da soluo auxiliar (fornecido no mtodo)
        d_aux[] = new double[10],
        // vetor de tenso de cada barra da soluo auxiliar (fornecido no mtodo)
        t_aux[] = new double[10],
        // vetor de deslocamento de cada barra da soluo auxiliar (fornecido no mtodo)
        u_aux[] = new double[12],
        // vetor (tensao_barra / tensao_max) para cada barra da soluo auxiliar
        tensao_quoc_aux[] = new double[10],
        // vetor (desl_barra / desl_max) para cada barra da soluo auxiliar
        desl_quoc_aux[] = new double[12],
        // armazena os dados modificados pelo mtodo
        dados[] = new double[5],
        retor[] = {
        fo, peso_trelica};

    double fo_melhor = 100000,
        fo_aux = 0, // funcao objetivo da solucao auxiliar
        peso_trelica_aux = 0; // peso da estrutura na solucao auxiliar

    for (int i = 0; i < 10; i++) {
      s_aux[i] = s[i];
    }

    int k = 1;

    while (k <= 2) {

      switch (k) {

        case 1:
          for (int i = 0; i < 10; i++) {
            for (int j = 0; j < 42; j++) {
              if (s_aux[i] == a[j]) {
                if (j <= (40)) {
                  dados = um_para_cima(i, j, deslocamento_max, tensao_max, a,
                                       s_aux,
                                       fo_melhor, densidade_barra, d_aux, t_aux,
                                       u_aux,
                                       tensao_quoc_aux, desl_quoc_aux, fo_aux,
                                       peso_trelica_aux);

                  fo_aux = dados[0];
                  fo_melhor = dados[1];
                  peso_trelica_aux = dados[2];
                }
                if (j != 0) {
                  dados = um_para_baixo(i, j, deslocamento_max, tensao_max, a,
                                        s_aux,
                                        fo_melhor, densidade_barra, d_aux,
                                        t_aux,
                                        u_aux, tensao_quoc_aux, desl_quoc_aux,
                                        fo_aux,
                                        peso_trelica_aux);

                  fo_aux = dados[0];
                  fo_melhor = dados[1];
                  peso_trelica_aux = dados[2];
                }
                break;
              }
            } // for
          } // for
          break;

        case 2:
          for (int i = 0; i < s.length; i++) {
            for (int j = 0; j < a.length; j++) {
              if (s_aux[i] == a[j]) {
                if (j <= (39)) {
                  dados = dois_para_cima(i, j, deslocamento_max, tensao_max, a,
                                         s_aux,
                                         fo_melhor, densidade_barra, d_aux,
                                         t_aux,
                                         u_aux, tensao_quoc_aux, desl_quoc_aux,
                                         fo_aux,
                                         peso_trelica_aux);
                  fo_aux = dados[0];
                  fo_melhor = dados[1];
                  peso_trelica_aux = dados[2];
                }
                if (j > 1) {
                  dados = dois_para_baixo(i, j, deslocamento_max, tensao_max, a,
                                          s_aux, fo_melhor, densidade_barra,
                                          d_aux, t_aux, u_aux, tensao_quoc_aux,
                                          desl_quoc_aux, fo_aux,
                                          peso_trelica_aux);
                  fo_aux = dados[0];
                  fo_melhor = dados[1];
                  peso_trelica_aux = dados[2];
                }
                break;
              }
            } // for
          } // for
          break;

      } // switch

      if (fo_aux < fo) {

        fo = fo_aux;
        peso_trelica = peso_trelica_aux;
        for (int i = 0; i < 10; i++) {
          s[i] = s_aux[i];
          d[i] = d_aux[i];
          t[i] = t_aux[i];
          tensao_quoc[i] = tensao_quoc_aux[i];
        }
        for (int i = 0; i < 12; i++) {
          u[i] = u_aux[i];
          desl_quoc[i] = desl_quoc_aux[i];
        }
        retor[0] = fo_aux;
        retor[1] = peso_trelica_aux;
        k = 1;
      }
      else
        k++;
    } // while

    return retor;
  } // fim do mtodo vnd

      /*----------------------------------------------------------------------------
   VNS
       ---------------------------------------------------------------------------*/
  private double[] vns(double[] a, double[] s, double fo,
                       double densidade_barra,
                       int deslocamento_max, int tensao_max,
                       double peso_trelica,
                       double[] d, double[] t, double[] u, double[] tensao_quoc,
                       double[] desl_quoc) {

    // vetor solucao corrente auxiliar 1
    double s_aux1[] = new double[10],
        // vetor de comprimento de cada barra da soluo auxiliar 1 (fornecido no mtodo)
        d_aux1[] = new double[10],
        // vetor de tenso de cada barra da soluo auxiliar 1 (fornecido no mtodo)
        t_aux1[] = new double[10],
        // vetor de deslocamento de cada barra da soluo auxiliar 1 (fornecido no mtodo)
        u_aux1[] = new double[12],
        // vetor (tensao_barra / tensao_max) para cada barra da soluo auxiliar 1
        tensao_quoc_aux1[] = new double[10],
        // vetor (desl_barra / desl_max) para cada barra da soluo auxiliar 1
        desl_quoc_aux1[] = new double[12],
        // armazena os dados modificados pelo mtodo
        dados[] = new double[5],
        retor[] = {
        fo, peso_trelica};

    double fo_aux1 = 0, // funcao objetivo da solucao auxiliar 1
        peso_trelica_aux1 = 0; // peso da estrutura na solucao auxiliar 1

    int ind_a1, ind_a2, ind_a3, ind_s1, ind_s2, ind_s3, cont1, cont2, cont3,
        cont4, cont5, cont6, cont7, cont8, cont9, cont10,
        ind_a4, ind_a5, ind_a6, ind_a7, ind_a8, ind_a9, ind_a10, rand_if;

    double area_aux1, area_aux2, area_aux3, aux1, aux2, aux3, aux4, aux5, aux6,
        aux7,
        aux8, aux9, aux10;
    ;

    for (int i = 0; i < 10; i++) {
      s_aux1[i] = s[i];
    }

    long hora_ini = System.currentTimeMillis(),
        hora_fim = 0;

    while ( (hora_fim - hora_ini) <= 5 * (60000)) {

      int k = 1;

      while (k <= 4) {

        switch (k) {

          case 1:

            do {

              ind_a1 = (int) (Math.random() * 42);
              ind_s1 = (int) (Math.random() * 10);
              area_aux1 = s_aux1[ind_s1];
              // troca uma posio qualquer do vetor s_aux1
              s_aux1[ind_s1] = a[ind_a1];

                  /* Chama o mtodo para calcular a tenso e o deslocamento da soluo corrente.
                         Aps isso, preenchemos o vetor d, t, u  */
              calculos(s_aux1, d_aux1, t_aux1, u_aux1);

              peso_trelica_aux1 = calcula_peso_trelica(s_aux1, d_aux1,
                  densidade_barra);

              set_vetores_quociente(deslocamento_max, tensao_max, t_aux1,
                                    u_aux1, tensao_quoc_aux1, desl_quoc_aux1);

              fo_aux1 = calcula_fo(peso_trelica_aux1, tensao_quoc_aux1,
                                   desl_quoc_aux1);

              if (fo_aux1 != peso_trelica_aux1) {
                s_aux1[ind_s1] = area_aux1;
              }

            }
            while (fo_aux1 != peso_trelica_aux1);

            break;

          case 2:

            do {

              ind_a1 = (int) (Math.random() * 42);
              ind_s1 = (int) (Math.random() * 10);

              ind_a2 = (int) (Math.random() * 42);
              ind_s2 = (int) (Math.random() * 10);

              area_aux1 = s_aux1[ind_s1];
              area_aux2 = s_aux1[ind_s2];

              // troca uma posio qualquer do vetor s_aux1
              s_aux1[ind_s1] = a[ind_a1];
              s_aux1[ind_s2] = a[ind_a2];

                  /* Chama o mtodo para calcular a tenso e o deslocamento da soluo corrente.
                         Aps isso, preenchemos o vetor d, t, u  */
              calculos(s_aux1, d_aux1, t_aux1, u_aux1);

              peso_trelica_aux1 = calcula_peso_trelica(s_aux1, d_aux1,
                  densidade_barra);

              set_vetores_quociente(deslocamento_max, tensao_max, t_aux1,
                                    u_aux1, tensao_quoc_aux1, desl_quoc_aux1);

              fo_aux1 = calcula_fo(peso_trelica_aux1, tensao_quoc_aux1,
                                   desl_quoc_aux1);

              if (fo_aux1 != peso_trelica_aux1) {
                s_aux1[ind_s1] = area_aux1;
                s_aux1[ind_s2] = area_aux2;
              }

            }
            while (fo_aux1 != peso_trelica_aux1);

            break;

          case 3:

            do {

              ind_a1 = (int) (Math.random() * 42);
              ind_s1 = (int) (Math.random() * 10);

              ind_a2 = (int) (Math.random() * 42);
              ind_s2 = (int) (Math.random() * 10);

              ind_a3 = (int) (Math.random() * 42);
              ind_s3 = (int) (Math.random() * 10);

              area_aux1 = s_aux1[ind_s1];
              area_aux2 = s_aux1[ind_s2];
              area_aux3 = s_aux1[ind_s3];

              // troca uma posio qualquer do vetor s_aux1
              s_aux1[ind_s1] = a[ind_a1];
              s_aux1[ind_s2] = a[ind_a2];
              s_aux1[ind_s3] = a[ind_a3];

                  /* Chama o mtodo para calcular a tenso e o deslocamento da soluo corrente.
                             Aps isso, preenchemos o vetor d, t, u  */
              calculos(s_aux1, d_aux1, t_aux1, u_aux1);

              peso_trelica_aux1 = calcula_peso_trelica(s_aux1, d_aux1,
                  densidade_barra);

              set_vetores_quociente(deslocamento_max, tensao_max, t_aux1,
                                    u_aux1, tensao_quoc_aux1, desl_quoc_aux1);

              fo_aux1 = calcula_fo(peso_trelica_aux1, tensao_quoc_aux1,
                                   desl_quoc_aux1);

              if (fo_aux1 != peso_trelica_aux1) {
                s_aux1[ind_s1] = area_aux1;
                s_aux1[ind_s2] = area_aux2;
                s_aux1[ind_s3] = area_aux3;
              }

            }while (fo_aux1 != peso_trelica_aux1);
            break;

          case 4:
            do {
              cont1 = 0;
              cont2 = 0;
              cont3 = 0;
              cont4 = 0;
              cont5 = 0;
              cont6 = 0;
              cont7 = 0;
              cont8 = 0;
              cont9 = 0;
              cont10 = 0;

              ind_a1 = (int) (Math.random() * 42);
              ind_a2 = (int) (Math.random() * 42);
              ind_a3 = (int) (Math.random() * 42);
              ind_a4 = (int) (Math.random() * 42);
              ind_a5 = (int) (Math.random() * 42);
              ind_a6 = (int) (Math.random() * 42);
              ind_a7 = (int) (Math.random() * 42);
              ind_a8 = (int) (Math.random() * 42);
              ind_a9 = (int) (Math.random() * 42);
              ind_a10 = (int) (Math.random() * 42);

              aux1 = s_aux1[0];
              aux2 = s_aux1[1];
              aux3 = s_aux1[2];
              aux4 = s_aux1[3];
              aux5 = s_aux1[4];
              aux6 = s_aux1[5];
              aux7 = s_aux1[6];
              aux8 = s_aux1[7];
              aux9 = s_aux1[8];
              aux10 = s_aux1[9];

              rand_if = (int) (Math.random() * 2);
              if (0 == rand_if) {
                cont1 = 1;
                s_aux1[0] = a[ind_a1];
              }
              rand_if = (int) (Math.random() * 2);
              if (0 == rand_if) {
                cont2 = 1;
                s_aux1[1] = a[ind_a2];
              }
              rand_if = (int) (Math.random() * 2);
              if (0 == rand_if) {
                cont3 = 1;
                s_aux1[2] = a[ind_a3];
              }
              rand_if = (int) (Math.random() * 2);
              if (0 == rand_if) {
                cont4 = 1;
                s_aux1[3] = a[ind_a4];
              }
              rand_if = (int) (Math.random() * 2);
              if (0 == rand_if) {
                cont5 = 1;
                s_aux1[4] = a[ind_a5];
              }
              rand_if = (int) (Math.random() * 2);
              if (0 == rand_if) {
                cont6 = 1;
                s_aux1[5] = a[ind_a6];
              }
              rand_if = (int) (Math.random() * 2);
              if (0 == rand_if) {
                cont7 = 1;
                s_aux1[6] = a[ind_a7];
              }
              rand_if = (int) (Math.random() * 2);
              if (0 == rand_if) {
                cont8 = 1;
                s_aux1[7] = a[ind_a8];
              }
              rand_if = (int) (Math.random() * 2);
              if (0 == rand_if) {
                s_aux1[8] = a[ind_a9];
                cont9 = 1;
              }
              rand_if = (int) (Math.random() * 2);
              if (0 == rand_if) {
                cont10 = 1;
                s_aux1[9] = a[ind_a10];
              }
                  /* Chama o mtodo para calcular a tenso e o deslocamento da soluo corrente.
                             Aps isso, preenchemos o vetor d, t, u  */
              calculos(s_aux1, d_aux1, t_aux1, u_aux1);

              peso_trelica_aux1 = calcula_peso_trelica(s_aux1, d_aux1,
                  densidade_barra);

              set_vetores_quociente(deslocamento_max, tensao_max, t_aux1,
                                    u_aux1, tensao_quoc_aux1, desl_quoc_aux1);

              fo_aux1 = calcula_fo(peso_trelica_aux1, tensao_quoc_aux1,
                                   desl_quoc_aux1);

              if (fo_aux1 != peso_trelica_aux1) {
                if (cont1 == 1)
                  s_aux1[0] = aux1;
                if (cont2 == 1)
                  s_aux1[1] = aux2;
                if (cont3 == 1)
                  s_aux1[2] = aux3;
                if (cont4 == 1)
                  s_aux1[3] = aux4;
                if (cont5 == 1)
                  s_aux1[4] = aux5;
                if (cont6 == 1)
                  s_aux1[5] = aux6;
                if (cont7 == 1)
                  s_aux1[6] = aux7;
                if (cont8 == 1)
                  s_aux1[7] = aux8;
                if (cont9 == 1)
                  s_aux1[8] = aux9;
                if (cont10 == 1)
                  s_aux1[9] = aux10;
              }

            }while (fo_aux1 != peso_trelica_aux1);
            break;

        } // whitch

        vnd(a, s_aux1, fo_aux1, densidade_barra, deslocamento_max,
            tensao_max,
            peso_trelica_aux1, d_aux1, t_aux1, u_aux1, tensao_quoc_aux1,
            desl_quoc_aux1);

        if (fo_aux1 < fo) {

          fo = fo_aux1;
          peso_trelica = peso_trelica_aux1;
          for (int a1 = 0; a1 < 10; a1++) {
            s[a1] = s_aux1[a1];
            d[a1] = d_aux1[a1];
            t[a1] = t_aux1[a1];
            tensao_quoc[a1] = tensao_quoc_aux1[a1];
          }
          for (int a1 = 0; a1 < 12; a1++) {
            u[a1] = u_aux1[a1];
            desl_quoc[a1] = desl_quoc_aux1[a1];
          }
          retor[0] = fo_aux1;
          retor[1] = peso_trelica_aux1;
          k = 1;
        }
        else
          k++;
      } // while

      hora_fim = System.currentTimeMillis();

    } //while

    return retor;

  } // fim do mtodo vns

      /*----------------------------------------------------------------------------
     FIM   FIM DOS MTODOS AUXILIARES
       ----------------------------------------------------------------------------*/

      /*----------------------------------------------------------------------------
     MTODOS PARA CALCULOS
       ----------------------------------------------------------------------------*/
  private void calculos(double[] area, double[] comp, double[] tensao,
                        double[] desl) {

    double fn[] = new double[19], // foras nodais aplicadas nas direes x e y
        ue[] = new double[19], // vetor de deslocamento de um elemento (ref. local)
        ueg[] = new double[19], // vetor de deslocamento de um elemento (ref. global)
        esf[] = new double[5], // esforos em um elemento
        t[] = new double[10], // vetor fora de cada barra da trelia
        // vetor rea da soluo corrente
        a[] = new double[11],
        // coordenadas dos pontos nodais
        x[] = {
        0, 720, 720, 360, 360, 0, 0}
        ,
        y[] = {
        0, 360, 0, 360, 0, 360, 0}
        ,

        zi[] = new double[11], // momento de inercia da seo tranversal
        f[] = new double[21], // vetor de foras (ref. global)
        u[] = new double[21], // vetor de deslocamento (ref. global)
        sg[][] = new double[20][20], // matriz global
        s[][] = new double[5][5], // matriz de rigidez no referencial local
        r[][] = new double[5][5], // matriz de rotao
        sr[][] = new double[5][5], // produto s * r
        rsr[][] = new double[5][5], // produto r' * s * r

        esfg[] = new double[5],
        reac[] = new double[21];

    int ic[] = new int[51], // ndice de condies de contorno (1 ou 0)
        // incidencia
        no1[] = {
        0, 5, 3, 6, 4, 3, 1, 5, 6, 3, 4}
        ,
        no2[] = {
        0, 3, 1, 4, 2, 4, 2, 4, 3, 2, 1}
        ,
        // incidencia de um elemento
        kk[] = new int[3];

    int nno = 6, // nmero de pontos nodais
        nelpor = 10, // nmero de elementos da trelia
        ncc = 2, // nmero de nos com deslocamentos impedidos
        nnc = 2, // nmero de nos com foras nodais aplicadas
        ngl = 2 * nno, // nmero de grau de liberdade da estrutura
        nel = 1, // nmero de um elemento
        nn = 0, // nmero de um no (com vinculao ou carga)
        nelm = nelpor, // nmero de elementos
        e = 10000; // mdulo der elasticidade

    double dx = 0, // projeo de um elemento sobre o eixo x
        dy = 0, // projeo de um elemento sobre o eixo y
        x1 = 0, // comprimento de um elemento
        cx = 0, // cossenos diretores de um elemento (eixo x)
        cy = 0, // cossenos diretores de um elemento (eixo y)
        aux = 0; // varivel auxiliar na triangularizao

    // contadores
    int i = 0, j = 0, k = 0, l = 0, m = 0, n = 0, k1 = 0, l1 = 0;

    // preenche o vetor a
    a[0] = 0;
    for (int a1 = 0; a1 < 10; a1++) {
      a[a1 + 1] = area[a1];
    }

    // forma o vetor de foras
    nn = 2;
    fn[1] = 0;
    fn[2] = -100;
    for (int a1 = 1; a1 <= 2; a1++) {
      k = 2 * (nn - 1) + a1;
      f[k] = fn[a1];
    }
    nn = 4;
    fn[1] = 0;
    fn[2] = -100;
    for (int a1 = 1; a1 <= 2; a1++) {
      k = 2 * (nn - 1) + a1;
      f[k] = fn[a1];
    }
    nn = 0;

    // montagem da matriz de rigidez da estrutura
    for (nel = 1; nel <= nelm; nel++) { // for 1
      kk[1] = no1[nel];
      kk[2] = no2[nel];

      // formao da matriz de rigidez da estrutura
      forma_matrizes(s, r, x, y, a, zi, kk, e, nel, cx, cy, x1, dx, dy, comp);

      // multiplicao sr = s * r
      for (int a1 = 1; a1 <= 4; a1++) { // for 2
        for (int b1 = 1; b1 <= 4; b1++) {
          sr[a1][b1] = 0;
          for (int c1 = 1; c1 <= 4; c1++) {
            sr[a1][b1] += s[a1][c1] * r[c1][b1];
          }
        }
      } // for 2

      // multiplicao rsr = r' * sr
      for (int a1 = 1; a1 <= 4; a1++) { // for 3
        for (int b1 = 1; b1 <= 4; b1++) {
          rsr[a1][b1] = 0;
          for (int c1 = 1; c1 <= 4; c1++) {
            rsr[a1][b1] += r[c1][a1] * sr[c1][b1];
          }
        }
      } // for 3

      // acumular na matriz de rigidez global a contribuio do elemento
      for (int a1 = 1; a1 <= 2; a1++) { // for 4
        m = 2 * (kk[a1] - 1);
        for (int b1 = 1; b1 <= 2; b1++) {
          n = 2 * (kk[b1] - 1);
          k1 = 0;
          for (int c1 = 2 * a1 - 1; c1 <= 2 * a1; c1++) {
            k1 = k1 + 1;
            l1 = 0;
            for (int d1 = 2 * b1 - 1; d1 <= 2 * b1; d1++) {
              l1 = l1 + 1;
              sg[m + k1][n + l1] += rsr[c1][d1];
            }
          }
        }
      } // for 4
    } // for 1

    // impor as condicoes de contorno (tecnica de 1 a 0)
    for (int a1 = 1; a1 <= nno; a1++) {
      for (int b1 = 1; b1 <= 2; b1++) {
        ic[2 * (a1 - 1) + b1] = 0;
      }
    }

    nn = 5;
    ic[2 * (nn - 1) + 1] = 1;
    ic[2 * (nn - 1) + 2] = 1;
    for (int b1 = 1; b1 <= 2; b1++) {
      if (ic[2 * (nn - 1) + b1] == 1) {
        l = 2 * (nn - 1) + b1;
        for (int c1 = 1; c1 <= ngl; c1++) {
          if (c1 != l) {
            f[c1] = f[c1] - sg[c1][l] * f[l];
            sg[c1][l] = 0;
            sg[l][c1] = 0;
          }
        }
        sg[l][l] = 1;
      }
    }
    nn = 6;
    ic[2 * (nn - 1) + 1] = 1;
    ic[2 * (nn - 1) + 2] = 1;
    for (int b1 = 1; b1 <= 2; b1++) {
      if (ic[2 * (nn - 1) + b1] == 1) {
        l = 2 * (nn - 1) + b1;
        for (int c1 = 1; c1 <= ngl; c1++) {
          if (c1 != l) {
            f[c1] = f[c1] - sg[c1][l] * f[l];
            sg[c1][l] = 0;
            sg[l][c1] = 0;
          }
        }
        sg[l][l] = 1;
      }
    }

    // resolver o sistema de equaes(Mtodo de Gauss)

    // triangularizao
    for (int a1 = 2; a1 <= ngl; a1++) {
      for (int b1 = a1; b1 <= ngl; b1++) {
        aux = sg[b1][a1 - 1] / sg[a1 - 1][a1 - 1];
        f[b1] = f[b1] - aux * f[a1 - 1];
        for (int c1 = a1; c1 <= ngl; c1++) {
          sg[b1][c1] = sg[b1][c1] - aux * sg[a1 - 1][c1];
        }
      }
    }

    // retro-substituio
    u[ngl] = f[ngl] / sg[ngl][ngl];
    for (int a1 = (ngl - 1); a1 >= 1; a1--) {
      u[a1] = f[a1];
      if (ic[a1] == 0) {
        for (int b1 = a1 + 1; b1 <= ngl; b1++) {
          u[a1] = u[a1] - sg[a1][b1] * u[b1];
        }
        u[a1] = u[a1] / sg[a1][a1];
      }
    }

    // prenche o vetor deslocamento
    for (int a1 = 1; a1 <= 12; a1++) {
      desl[a1 - 1] = Math.abs(u[a1]);
    }

    // esforos nos elementos
    for (nel = 1; nel <= nelm; nel++) {
      // vetor de deslocamentos dos elemento (ref. global)
      kk[1] = no1[nel];
      kk[2] = no2[nel];
      for (int a1 = 1; a1 <= 2; a1++) {
        k = 2 * (kk[a1] - 1);
        l = 0;
        for (int b1 = 2 * a1 - 1; b1 <= 2 * a1; b1++) {
          l = l + 1;
          ueg[b1] = u[k + l];
        }
      }

      // formao da matriz de rigidez e rotao
      forma_matrizes(s, r, x, y, a, zi, kk, e, nel, cx, cy, x1, dx, dy, comp);

      // rotao dos deslocamentos para o ref. local
      for (int a1 = 1; a1 <= 4; a1++) {
        ue[a1] = 0;
        for (int b1 = 1; b1 <= 4; b1++) {
          ue[a1] += r[a1][b1] * ueg[b1];
        }
      }

      // calculo e impresso dos esforos(produto esf = s * ue)
      for (int a1 = 1; a1 <= 4; a1++) {
        esf[a1] = 0;
        for (int b1 = 1; b1 <= 4; b1++) {
          esf[a1] += s[a1][b1] * ue[b1];
        }
      }

      // preenche o vetor fora de cada barra da trelia
      t[nel - 1] = Math.abs(esf[3]);

      // calculo e impresso das reaes de apoio
      // rotao dos esforos para o sistema global
      for (int a1 = 1; a1 <= 4; a1++) {
        esfg[a1] = 0;
        for (int b1 = 1; b1 <= 4; b1++) {
          esfg[a1] += r[b1][a1] * esf[b1];
        }
      }
      for (int a1 = 1; a1 <= 2; a1++) {
        for (int b1 = 1; b1 <= 2; b1++) {
          if (ic[2 * (kk[a1] - 1) + b1] != 0) {
            m = 2 * (kk[a1] - 1) + b1;
            n = 2 * (a1 - 1) + b1;
            reac[m] += esfg[n];
          }
        }
      }
    }

    for (int a1 = 0; a1 < 10; a1++) {

      // preenche o vetor tenso da soluo corrente
      tensao[a1] = t[a1] / area[a1];

    } // for

  } // fim do mtodo calculos

  // formao das matrizes de rigidez e rotao
  private static void forma_matrizes(double[][] s, double[][] r, double[] x,
                                     double[] y, double[] a, double[] zi,
                                     int[] kk, double e, int nel, double cx,
                                     double cy, double x1, double dx, double dy,
                                     double[] comp) {

    // comprimento do elemento e cossenos diretores
    dx = x[kk[2]] - x[kk[1]];
    dy = y[kk[2]] - y[kk[1]];
    x1 = Math.sqrt( (dx * dx) + (dy * dy));

    // preenche o vetor comprimento da soluo corrente
    comp[nel - 1] = x1;

    cx = dx / x1;
    cy = dy / x1;

    // zerar todas as posies das matrizes s e r
    for (int a1 = 1; a1 <= 4; a1++) {
      for (int b1 = 1; b1 <= 4; b1++) {
        s[a1][b1] = 0;
        r[a1][b1] = 0;
      }
    }

    // matriz de rotao(elementos no nulos)
    r[1][1] = cx;
    r[1][2] = cy;
    r[2][1] = -cy;
    r[2][2] = cx;
    r[3][3] = cx;
    r[4][4] = cx;
    r[3][4] = cy;
    r[4][3] = -cy;

    // matriz de rigidez(elementos no nulos)
    s[1][1] = e * a[nel] / x1;
    s[1][3] = -e * a[nel] / x1;
    s[3][3] = e * a[nel] / x1;

    // parte simetrica
    for (int a1 = 2; a1 <= 4; a1++) {
      for (int b1 = 1; b1 <= (a1 - 1); b1++) {
        s[a1][b1] = s[b1][a1];
      }
    }
  } // fim do mtodo forma_matrizes
      /*----------------------------------------------------------------------------
   FIM DOS MTODOS PARA CALCULOS
       ----------------------------------------------------------------------------*/

} // fim da classe Implementacao